--- clamav-0.70-rc/clamd/scanner.c	Mon Mar 15 15:03:12 2004
+++ clamav-0.70-rc-jm/clamd/scanner.c	Tue Mar 30 18:28:29 2004
@@ -186,7 +186,7 @@
 
 int scanstream(int odesc, unsigned long int *scanned, const struct cl_node *root, const struct cl_limits *limits, int options, const struct cfgstruct *copt)
 {
-	int ret, portscan = CL_DEFAULT_MAXPORTSCAN, sockfd, port, acceptd, tmpd, bread, retval;
+	int ret, portscan = CL_DEFAULT_MAXPORTSCAN, sockfd, port, acceptd, tmpd, bread, btread, retval;
 	long int size = 0, maxsize = 0;
 	short bound = 0;
 	const char *virname;
@@ -260,22 +260,18 @@
 	if((cpt = cfgopt(copt, "StreamMaxLength")))
 	    maxsize = cpt->numarg;
 
+	btread = sizeof(buff);
 	while((retval = poll_fd(acceptd, CL_DEFAULT_SCANTIMEOUT)) == 1) {
-	    bread = read(acceptd, buff, sizeof(buff));
+	    bread = read(acceptd, buff, btread);
 	    if (bread <= 0) {
 		break;
 	    }
 	    size += bread;
 
-	    if(maxsize && (size + sizeof(buff)) > maxsize) {
-		shutdown(sockfd, 2);
-		close(sockfd);
-		close(acceptd);
-		mdprintf(odesc, "Size exceeded ERROR\n");
-		logg("^ScanStream: Size exceeded (stopped at %d, max: %d)\n", size, maxsize);
-		if(tmp)
-		    fclose(tmp);
-		return -1;
+	    btread = ( (maxsize && ( size + btread > maxsize)) ? (maxsize - size) : btread);
+	    if(btread == 0) {
+		logg("^ScanStream: Size limit reached (max: %d)\n",  maxsize);
+		break;
 	    }
 
 	    if(write(tmpd, buff, bread) < 0) {
